[力扣题解]37. 解数独

题目:37. 解数独

思路

回溯法

代码

cpp 复制代码
class Solution {
public:
    bool function(vector<vector<char>>& board)
    {
        int i, j;
        char k;
        for(i = 0; i < 9; i++)
        {
            for(j = 0; j < 9; j++)
            {
                // 为空
                if(board[i][j] == '.')
                {
                    for(k = '1'; k <= '9'; k++)
                    {
                        if(right(board, i, j, k))
                        {
                            board[i][j] = k;
                            if(function(board))
                            {
                                return true;
                            }
                            board[i][j] = '.';
                        }
                    }
                    return false;
                }
            }
        }
        // 都填满了
        return true;
    }

    // 检验合法性
    bool right(vector<vector<char>>& board, int row, int col, char num)
    {
        cout << "right start" << endl;
        int i, j;
        int start_i, start_j;
        // 行
        for(j = 0; j < 9; j++)
        {
            if(j != col && board[row][j] == num)
            {
                return false;
            }
        }
        // 列
        for(i = 0; i < 9; i++)
        {
            if(i != row && board[i][col] == num)
            {
                return false;
            }
        }
        // 九宫格
        start_i = (row / 3) * 3;
        start_j = (col / 3) * 3;
        for(i = start_i; i < start_i+3; i++)
        {
            for(j = start_j; j < start_j+3; j++)
            {
                if(!(i == row && j == col) && board[i][j] == num)
                {
                    return false;
                }
            }
        }
        return true;
    }

    void solveSudoku(vector<vector<char>>& board) {
        function(board);
    }
};

这里的回溯函数设计的很有趣,返回值为bool,所以没有特地写回溯结束的逻辑;

确定当前元素所在九宫格的位置时,用

cpp 复制代码
start_i = (row / 3) * 3;
start_j = (col / 3) * 3;

来表示九宫格的起点坐标;

function()什么时候return

  • 对于一个为空的格子,9个数字都试完还不对,就return false;
  • 如果所有格子都填满了,并且没有检查出错误,就return true;
  • 发现当这个格子填好之后,整个棋盘也填好了,就return true;
相关推荐
Nil2083 小时前
leetcode 118杨辉三角
算法·leetcode·职场和发展
wanderist.5 小时前
线性筛法详解:从筛质数到欧拉函数、Möbius 函数与约数函数
java·数据结构·算法
All for pursuit.5 小时前
【设计-1】208.实现Trie (前缀树)
数据结构·c++·算法·leetcode
weixin_307779135 小时前
C++代码实现MATLAB中的crossval函数功能
开发语言·c++·算法·matlab
青少儿编程课堂6 小时前
背包问题(0/1 背包与完全背包)解题精讲——动态规划入门
c++·python·算法·bfs·信息学竞赛
光影少年6 小时前
为什么 JavaScript 中 0.1 + 0.2 !== 0.3,如何让其相等?
前端·javascript·算法
HEJOO96 小时前
Linux 设备驱动系列——使用全局工作队列
java·linux·算法
Code_Solitude6 小时前
c语言:递归
java·c语言·算法
edtoplort7 小时前
OpenAI紧急叫停GPT-6.1 Astra训练,奥尔特曼为何踩刹车
人工智能·gpt·算法
蒜香可达鸭7 小时前
让视频生成流水线跑不崩:一个事件溯源的多 Agent 可靠执行框架
算法